﻿Imports System.ComponentModel
Imports System.Data

Partial Public Class dtsParentChild


	Public Shared ReadOnly Dts As dtsParentChild = CreateDts()

	Private Shared Function CreateDts() As dtsParentChild
		If NotifyPropertyChanged.IsInDesignMode Then Return Nothing
		Dim dts = New dtsParentChild
		For Each tb As DataTable In dts.Tables
			tb.EnsureDefaults()
		Next
		Return dts
	End Function

	Private Sub InitAfterFill()
		'nach jeder Befüllung sind ggfs. iwelche Massen-Operationen auszuführen - bevor die Eventbehandlung sich aktiviert
	End Sub

	Partial Public Class ParentDataTable

		Private WithEvents _Attach As DataTableAttach = Me.Attach
		Private WithEvents _Active As ParentDataTable ' wenn Nothing ist, sind die Events deaktiviert

		Private Sub _Attach_Suspending(ByVal sender As Object, ByVal e As DataTableAttach.SuspendingEventArgs) Handles _Attach.Suspending
			If e.BeforeEnd AndAlso e.Suspended = DataTableAttach.Suspend.TableIndicees Then Dts.InitAfterFill() ' bevor die Eventbehandlung sich aktiviert
			e.TriDecide(_Active, Nothing, Me)
		End Sub

		Private Sub ParentDataTable_ParentRowChanged(sender As Object, e As ParentRowChangeEvent) Handles _Active.ParentRowChanged
			If e.Action <> DataRowAction.Add Then Return
			For i = 0 To 3
				Dts.ParentChild.AddParentChildRow(e.Row, $"Name{e.Row.Name}_{i}")
			Next
		End Sub

	End Class ' ParentDataTable

End Class
